## kdeconnect 1.3.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project(kdeconnect)

set(KDECONNECT_VERSION_MAJOR 1)
set(KDECONNECT_VERSION_MINOR 3)
set(KDECONNECT_VERSION_PATCH 0)
set(KDECONNECT_VERSION "${KDECONNECT_VERSION_MAJOR}.${KDECONNECT_VERSION_MINOR}.${KDECONNECT_VERSION_PATCH}")

set(QT_MIN_VERSION "5.7.0")
set(KF5_MIN_VERSION "5.42.0")

find_package(ECM ${KF5_MIN_VERSION} REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} ${ECM_KDE_MODULE_DIR} ${CMAKE_SOURCE_DIR}/cmake)

find_package(Qt5 ${QT_MIN_VERSION} REQUIRED COMPONENTS Quick)

find_package(KF5 ${KF5_MIN_VERSION} REQUIRED COMPONENTS I18n ConfigWidgets DBusAddons IconThemes Notifications KIO KCMUtils)
find_package(KF5 ${KF5_MIN_VERSION} COMPONENTS DocTools)
find_package(Qca-qt5 2.1.0 REQUIRED)

include_directories(${CMAKE_SOURCE_DIR})

configure_file(kdeconnect-version.h.in ${CMAKE_CURRENT_BINARY_DIR}/kdeconnect-version.h)

include(KDEInstallDirs)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(KDECMakeSettings)
include(ECMAddTests)
include(ECMSetupVersion)
include(ECMInstallIcons)
include(FeatureSummary)

include(KDEConnectMacros.cmake)

add_definitions(-DQT_NO_URL_CAST_FROM_STRING -DQT_NO_KEYWORDS)

include(GenerateExportHeader)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_subdirectory(core)
add_subdirectory(kcm)
add_subdirectory(kcmplugin)
if(NOT WIN32)
	add_subdirectory(kio)
	add_subdirectory(plasmoid)
endif()
add_subdirectory(icon)
add_subdirectory(interfaces)

option(EXPERIMENTALAPP_ENABLED OFF)
if(EXPERIMENTALAPP_ENABLED)
    add_subdirectory(app)
endif()
add_subdirectory(daemon)
add_subdirectory(plugins)
add_subdirectory(cli)
add_subdirectory(indicator)
add_subdirectory(fileitemactionplugin)
add_subdirectory(urlhandler)
add_subdirectory(nautilus-extension)
if(KF5DocTools_FOUND)
    add_subdirectory(doc)
endif()

if(BUILD_TESTING)
    add_subdirectory(tests)
endif()

install(FILES org.kde.kdeconnect.kcm.appdata.xml DESTINATION ${KDE_INSTALL_METAINFODIR})
feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

find_package(KF5I18n CONFIG REQUIRED)
ki18n_install(po)

=== app/CMakeLists.txt ===
find_package(KF5 ${KF5_MIN_VERSION} REQUIRED COMPONENTS Declarative)

qt5_add_resources(kcapp_SRCS resources.qrc)

add_executable(kcapp main.cpp ${kcapp_SRCS})
target_link_libraries(kcapp Qt5::Quick Qt5::Widgets KF5::Declarative KF5::CoreAddons KF5::I18n)

install(TARGETS kcapp ${INSTALL_TARGETS_DEFAULT_ARGS})
install(PROGRAMS org.kde.kdeconnect.app.desktop DESTINATION ${XDG_APPS_INSTALL_DIR})

=== cli/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdeconnect-cli\")

add_executable(kdeconnect-cli kdeconnect-cli.cpp)
ecm_mark_nongui_executable(kdeconnect-cli)

target_link_libraries(kdeconnect-cli
    kdeconnectinterfaces
    KF5::CoreAddons
    KF5::I18n
)

install(TARGETS kdeconnect-cli ${INSTALL_TARGETS_DEFAULT_ARGS})

=== fileitemactionplugin/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN="kdeconnect-fileitemaction")
include_directories(${CMAKE_SOURCE_DIR})

add_library(kdeconnectfileitemaction MODULE sendfileitemaction.cpp)
target_link_libraries(kdeconnectfileitemaction
    KF5::KIOWidgets
    KF5::I18n
    kdeconnectinterfaces
)
install(TARGETS kdeconnectfileitemaction DESTINATION ${PLUGIN_INSTALL_DIR})
install(FILES kdeconnectsendfile.desktop DESTINATION ${SERVICES_INSTALL_DIR})

=== kio/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR})
add_definitions(-DTRANSLATION_DOMAIN="kdeconnect-kio")

set(kio_kdeconnect_PART_SRCS
   kiokdeconnect.cpp
)

add_library(kio_kdeconnect MODULE ${kio_kdeconnect_PART_SRCS})

target_link_libraries(kio_kdeconnect
    kdeconnectinterfaces
    Qt5::Core
    Qt5::Gui
    KF5::KIOCore
    KF5::I18n
)

########### install files ###############
install(TARGETS kio_kdeconnect DESTINATION ${PLUGIN_INSTALL_DIR})
install(FILES kdeconnect.protocol DESTINATION ${SERVICES_INSTALL_DIR})

=== plasmoid/declarativeplugin/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_BINARY_DIR}
                    ${CMAKE_CURRENT_SOURCE_DIR}
                    ${CMAKE_SOURCE_DIR}
                    ${CMAKE_BINARY_DIR})

set(kdeconnectdeclarativeplugin_SRC
    kdeconnectdeclarativeplugin.cpp
    responsewaiter.cpp
)

set(kdeconnectdeclarativeplugin_MOC
  objectfactory.h
)

qt5_wrap_cpp(kdeconnectdeclarativeplugin_SRC ${kdeconnectdeclarativeplugin_MOC})

add_library(kdeconnectdeclarativeplugin SHARED ${kdeconnectdeclarativeplugin_SRC})
target_link_libraries(kdeconnectdeclarativeplugin
    Qt5::Qml
    kdeconnectinterfaces
)
install(TARGETS kdeconnectdeclarativeplugin DESTINATION ${QML_INSTALL_DIR}/org/kde/kdeconnect)
install(FILES qmldir qml/PluginChecker.qml qml/DBusProperty.qml DESTINATION ${QML_INSTALL_DIR}/org/kde/kdeconnect)

=== plugins/screensaver-inhibit/CMakeLists.txt ===
set(kdeconnect_screensaver_inhibit_SRCS
    screensaverinhibitplugin.cpp
)

kdeconnect_add_plugin(kdeconnect_screensaver_inhibit JSON kdeconnect_screensaver_inhibit.json SOURCES ${kdeconnect_screensaver_inhibit_SRCS})

target_link_libraries(kdeconnect_screensaver_inhibit kdeconnectcore 
    Qt5::DBus
    KF5::I18n
    KF5::Notifications
)

=== debian/changelog ===
kdeconnect (1.3.0-0ubuntu1) bionic; urgency=medium

  * New upstream release (1.3.0) (LP: #1762479)
  * Install nautilus extension script
  * Update watchfile

 -- Rik Mills <rikmills@kubuntu.org>  Tue, 10 Apr 2018 08:13:13 +0100

kdeconnect (1.2.1-0ubuntu2) bionic; urgency=medium

  * Add misssing qml module runtime dependencies.

 -- Rik Mills <rikmills@kubuntu.org>  Fri, 06 Apr 2018 10:27:02 +0100

kdeconnect (1.2.1-0ubuntu1) bionic; urgency=medium

  [ Rik Mills ]
  * Update lintian overrides and fix other control fields
  * Transitional package priorities changed from 'extra' to 'optional'
  * New upstream release (1.2.1)
  * Update KF5 build depends to new required minimum of 5.42.0
  * Install translations

  [ Clive Johnston ]
  * New upstream release (1.2)

 -- Rik Mills <rikmills@kubuntu.org>  Sun, 28 Jan 2018 06:58:10 +0000

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/pkg-kde-tools/qt-kde-team/3/debian-qt-kde.mk

# hardening options stuff
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
# workaround for hardening on cmake
export CFLAGS := $(shell dpkg-buildflags --get CFLAGS) $(shell dpkg-buildflags --get CPPFLAGS)
export CXXFLAGS := $(shell dpkg-buildflags --get CXXFLAGS) $(shell dpkg-buildflags --get CPPFLAGS)
export LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS) -Wl,--as-needed

%:
	dh $@ --with=kf5,pkgkde-symbolshelper --parallel

override_dh_install:
	dh_install --list-missing

override_dh_auto_test:
	# Disable dh_auto_test at build time
	:

=== debian/tests/control ===
Tests: testsuite
Depends: @, @builddeps@, xvfb, xauth, openbox, dbus (>= 1.8), dpkg-dev
Restrictions: build-needed

## kdeconnect 1.3.1

=== kio/CMakeLists.txt ===
--- 
+++ 
@@ -11,6 +11,7 @@
     kdeconnectinterfaces
     Qt5::Core
     Qt5::Gui
+    Qt5::Network
     KF5::KIOCore
     KF5::I18n
 )

=== debian/changelog ===
kdeconnect (1.3.1-1) unstable; urgency=medium

  * Team upload.

  [ Maximiliano Curia ]
  * New revision
  * Drop --parallel dh option, obsolete with dh >= 11
  * Update Vcs fields

  [ Nicholas D Steeves ]
  * Enable GPG signature verification of upstream tarball.
  * Add Albert Vaca Cintora's (the upstream maintainer) gpg key.
  * New upstream version 1.3.1.
  * Use 'wrap-and-sort -bst' to sort dependencies.
  * Add fix_typos_in_lanlinkprovider.cpp.patch
  * Update upstream homepage URL.
  * Use secure URL for copyright format.
  * Add upstream metadata.

 -- Nicholas D Steeves <nsteeves@gmail.com>  Fri, 01 Jun 2018 16:07:13 -0400

kdeconnect (1.3.0-1) unstable; urgency=medium

  [ Maximiliano Curia ]
  * Update watch file
  * New upstream release (1.2.1).
  * Set the team as the maintainer
  * Drop plasma-workspace runtime dependency
  * Update testsuite
  * Bump to Standards-Version 4.1.4
  * Add suggests:
     + plasma-workspace, for the plasmoid
     + python-nautilus for the nautilus integration
  * New upstream release (1.3.0).
  * Update build-deps and deps with the info from cmake
  * Update copyright information
  * Refresh patches
  * Release to unstable

  [ Vangelis Mouhtsis ]
  * debian/{control,compat}: Bump DH version level to 11.
  * debian/control: Bump Standards-Version: to 4.1.3. No changes needed.
  * debian/control: Update Vcs-*: fields to salsa.debian.org.

  [ Scarlett Clark ]
  * Add missing qml modules

 -- Maximiliano Curia <maxy@debian.org>  Tue, 10 Apr 2018 17:24:16 +0200

kdeconnect (1.0.3-1) unstable; urgency=medium

  * New upstream release (1.0.3).
  * debian/watch: use https
  * Bump Standards-Version to 4.0.0, no changes needed.
  * Update vcs fields
  * Update Homepage field
  * Update build-deps and deps with the info from cmake
  * Add a .gitattributes file to use dpkg-mergechangelogs
  * Refresh patches
  * Release to unstable

 -- Maximiliano Curia <maxy@debian.org>  Thu, 13 Jul 2017 20:22:08 +0200

## kdeconnect 1.3.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 set(KDECONNECT_VERSION_MAJOR 1)
 set(KDECONNECT_VERSION_MINOR 3)
-set(KDECONNECT_VERSION_PATCH 0)
+set(KDECONNECT_VERSION_PATCH 3)
 set(KDECONNECT_VERSION "${KDECONNECT_VERSION_MAJOR}.${KDECONNECT_VERSION_MINOR}.${KDECONNECT_VERSION_PATCH}")
 
 set(QT_MIN_VERSION "5.7.0")
@@ -13,7 +13,7 @@
 find_package(ECM ${KF5_MIN_VERSION} REQUIRED NO_MODULE)
 set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} ${ECM_KDE_MODULE_DIR} ${CMAKE_SOURCE_DIR}/cmake)
 
-find_package(Qt5 ${QT_MIN_VERSION} REQUIRED COMPONENTS Quick)
+find_package(Qt5 ${QT_MIN_VERSION} REQUIRED COMPONENTS Quick Network)
 
 find_package(KF5 ${KF5_MIN_VERSION} REQUIRED COMPONENTS I18n ConfigWidgets DBusAddons IconThemes Notifications KIO KCMUtils)
 find_package(KF5 ${KF5_MIN_VERSION} COMPONENTS DocTools)

=== core/CMakeLists.txt ===
project(KDEConnectCore)

add_definitions(-DTRANSLATION_DOMAIN=\"kdeconnect-core\")

include_directories(
    ${CMAKE_CURRENT_BINARY_DIR}
)

add_subdirectory(backends/lan)
add_subdirectory(backends/loopback)

option(BLUETOOTH_ENABLED "Bluetooth support for kdeconnect" OFF)
if(BLUETOOTH_ENABLED)
    find_package(Qt5 ${QT_MIN_VERSION} REQUIRED COMPONENTS Bluetooth)
    add_subdirectory(backends/bluetooth)
endif()

set(kdeconnectcore_SRCS
    ${backends_kdeconnect_SRCS}

    backends/linkprovider.cpp
    backends/devicelink.cpp
    backends/pairinghandler.cpp
    backends/devicelinereader.cpp

    kdeconnectplugin.cpp
    kdeconnectpluginconfig.cpp
    pluginloader.cpp

    kdeconnectconfig.cpp
    dbushelper.cpp
    networkpacket.cpp
    filetransferjob.cpp
    daemon.cpp
    device.cpp
    core_debug.cpp
)

add_library(kdeconnectcore ${kdeconnectcore_SRCS})
target_link_libraries(kdeconnectcore
PUBLIC
    Qt5::Network
    KF5::CoreAddons
    qca-qt5
PRIVATE
    Qt5::DBus
    Qt5::Gui
    KF5::I18n
    KF5::ConfigCore
)

if (BLUETOOTH_ENABLED)
    target_compile_definitions(kdeconnectcore PRIVATE -DKDECONNECT_BLUETOOTH)
    target_link_libraries(kdeconnectcore PRIVATE Qt5::Bluetooth)
endif()

set_target_properties(kdeconnectcore PROPERTIES
    VERSION ${KDECONNECT_VERSION}
    SOVERSION ${KDECONNECT_VERSION_MAJOR}
)

target_include_directories(kdeconnectcore PUBLIC ${CMAKE_CURRENT_BINARY_DIR})
generate_export_header(kdeconnectcore EXPORT_FILE_NAME kdeconnectcore_export.h BASE_NAME KDEConnectCore)

install(TARGETS kdeconnectcore EXPORT kdeconnectLibraryTargets ${INSTALL_TARGETS_DEFAULT_ARGS} LIBRARY NAMELINK_SKIP)

=== daemon/CMakeLists.txt ===
project(kdeconnectd)

add_definitions(-DTRANSLATION_DOMAIN="kdeconnect-kded")

add_executable(kdeconnectd kdeconnectd.cpp)
target_link_libraries(kdeconnectd kdeconnectcore KF5::KIOWidgets KF5::DBusAddons KF5::Notifications KF5::I18n Qt5::Widgets)

ecm_mark_nongui_executable(kdeconnectd)

configure_file(kdeconnectd.desktop.cmake ${CMAKE_CURRENT_BINARY_DIR}/kdeconnectd.desktop)
configure_file(org.kde.kdeconnect.service.in ${CMAKE_CURRENT_BINARY_DIR}/org.kde.kdeconnect.service)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/kdeconnectd.desktop DESTINATION ${AUTOSTART_INSTALL_DIR})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.kde.kdeconnect.service DESTINATION ${DBUS_SERVICES_INSTALL_DIR})
install(TARGETS kdeconnectd DESTINATION ${LIBEXEC_INSTALL_DIR})

=== icon/CMakeLists.txt ===

ecm_install_icons(
ICONS
    256-apps-kdeconnect.png
    128-apps-kdeconnect.png
    32-apps-kdeconnect.png
    64-apps-kdeconnect.png
    48-apps-kdeconnect.png
    22-apps-kdeconnect.png
    16-apps-kdeconnect.png
    sc-apps-kdeconnect.svgz
DESTINATION
    ${ICON_INSTALL_DIR}
)

ecm_install_icons(
ICONS
    32-status-laptopconnected.png
    32-status-laptopdisconnected.png
    32-status-laptoptrusted.png
    32-status-smartphoneconnected.png
    32-status-smartphonedisconnected.png
    32-status-smartphonetrusted.png
    32-status-tabletconnected.png
    32-status-tabletdisconnected.png
    32-status-tablettrusted.png
    sc-status-laptopconnected.svg
    sc-status-laptopdisconnected.svg
    sc-status-laptoptrusted.svg
    sc-status-smartphoneconnected.svg
    sc-status-smartphonedisconnected.svg
    sc-status-smartphonetrusted.svg
    sc-status-tabletconnected.svg
    sc-status-tabletdisconnected.svg
    sc-status-tablettrusted.svg
DESTINATION
    ${ICON_INSTALL_DIR}
)

=== indicator/CMakeLists.txt ===
set(indicator_SRCS
    main.cpp
    deviceindicator.cpp
)

include(ECMAddAppIcon)
ecm_add_app_icon(indicator_SRCS ICONS
    ../icon/16-apps-kdeconnect.png
    ../icon/22-apps-kdeconnect.png
    ../icon/32-apps-kdeconnect.png
    ../icon/48-apps-kdeconnect.png
    ../icon/64-apps-kdeconnect.png
    ../icon/128-apps-kdeconnect.png
    ../icon/256-apps-kdeconnect.png
)

add_executable(kdeconnect-indicator ${indicator_SRCS})
target_link_libraries(kdeconnect-indicator Qt5::Widgets KF5::CoreAddons KF5::I18n KF5::Notifications KF5::DBusAddons KF5::KCMUtils kdeconnectinterfaces)

install(TARGETS kdeconnect-indicator ${INSTALL_TARGETS_DEFAULT_ARGS})
install(PROGRAMS org.kde.kdeconnect.nonplasma.desktop DESTINATION ${XDG_APPS_INSTALL_DIR})

=== interfaces/CMakeLists.txt ===
project(KDEConnectInterfaces)

function(geninterface source_h output_h)
    set(xml_file ${CMAKE_CURRENT_BINARY_DIR}/${output_h}.xml)
    qt5_generate_dbus_interface( ${source_h} ${xml_file})

    list(APPEND libkdeconnect_HEADERS ${CMAKE_CURRENT_BINARY_DIR}/${output_h})
    set_source_files_properties(${xml_file} PROPERTIES NO_NAMESPACE true)

    qt5_add_dbus_interface(libkdeconnect_SRC ${xml_file} ${output_h})
    set(libkdeconnect_SRC ${libkdeconnect_SRC} PARENT_SCOPE)
    set(libkdeconnect_HEADERS ${libkdeconnect_HEADERS} PARENT_SCOPE)
endfunction()

set(libkdeconnect_SRC
    dbusinterfaces.cpp
    devicesmodel.cpp
    notificationsmodel.cpp
    devicessortproxymodel.cpp
#    modeltest.cpp
)

set(libkdeconnect_public_HEADERS
    KDEConnect/DevicesModel
    KDEConnect/NotificationsModel
)

set(libkdeconnect_HEADERS
    devicesmodel.h
    notificationsmodel.h
    dbusinterfaces.h
    ${CMAKE_CURRENT_BINARY_DIR}/kdeconnectinterfaces_export.h
)

geninterface(${CMAKE_SOURCE_DIR}/core/daemon.h daemoninterface)
geninterface(${CMAKE_SOURCE_DIR}/core/device.h deviceinterface)
geninterface(${CMAKE_SOURCE_DIR}/plugins/battery/batterydbusinterface.h devicebatteryinterface)
geninterface(${CMAKE_SOURCE_DIR}/plugins/sftp/sftpplugin.h devicesftpinterface)
geninterface(${CMAKE_SOURCE_DIR}/plugins/notifications/notificationsdbusinterface.h devicenotificationsinterface)
geninterface(${CMAKE_SOURCE_DIR}/plugins/findmyphone/findmyphoneplugin.h devicefindmyphoneinterface)
geninterface(${CMAKE_SOURCE_DIR}/plugins/notifications/notification.h notificationinterface)
geninterface(${CMAKE_SOURCE_DIR}/plugins/mprisremote/mprisremoteplugin.h mprisremoteinterface)
geninterface(${CMAKE_SOURCE_DIR}/plugins/remotecontrol/remotecontrolplugin.h remotecontrolinterface)
geninterface(${CMAKE_SOURCE_DIR}/plugins/lockdevice/lockdeviceplugin.h lockdeviceinterface)
geninterface(${CMAKE_SOURCE_DIR}/plugins/remotecommands/remotecommandsplugin.h remotecommandsinterface)
geninterface(${CMAKE_SOURCE_DIR}/plugins/remotekeyboard/remotekeyboardplugin.h remotekeyboardinterface)


add_library(kdeconnectinterfaces SHARED ${libkdeconnect_SRC})
set_target_properties(kdeconnectinterfaces PROPERTIES
    VERSION ${KDECONNECT_VERSION}
    SOVERSION ${KDECONNECT_VERSION_MAJOR}
)

generate_export_header(kdeconnectinterfaces EXPORT_FILE_NAME ${CMAKE_CURRENT_BINARY_DIR}/kdeconnectinterfaces_export.h BASE_NAME KDEConnectInterfaces)

target_link_libraries(kdeconnectinterfaces
LINK_PUBLIC
    Qt5::Gui
    Qt5::DBus
LINK_PRIVATE
    KF5::ConfigCore
    KF5::I18n
)

configure_file(KDEConnectConfig.cmake.in ${CMAKE_BINARY_DIR}/interfaces/KDEConnectConfig.cmake @ONLY)

ecm_setup_version( "${KDECONNECT_VERSION_MAJOR}.${KDECONNECT_VERSION_MINOR}.${KDECONNECT_VERSION_PATCH}" VARIABLE_PREFIX KDECONNECTINTERFACES
                        VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/kdeconnectinterfaces_version.h"
                        PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KDEConnectConfigVersion.cmake"
                        SOVERSION ${KDECONNECT_VERSION_MAJOR})

install(TARGETS kdeconnectinterfaces EXPORT kdeconnectLibraryTargets ${INSTALL_TARGETS_DEFAULT_ARGS} LIBRARY NAMELINK_SKIP)

## Don't install header files until API/ABI policy is defined
#
# install(FILES ${libkdeconnect_HEADERS} DESTINATION ${INCLUDE_INSTALL_DIR}/kdeconnect COMPONENT Devel)
# install(FILES ${libkdeconnect_public_HEADERS} DESTINATION ${INCLUDE_INSTALL_DIR}/KDEConnect COMPONENT Devel)
# install(FILES ${CMAKE_BINARY_DIR}/interfaces/KDEConnectConfig.cmake
#               ${CMAKE_BINARY_DIR}/interfaces/KDEConnectConfigVersion.cmake
#         DESTINATION ${LIB_INSTALL_DIR}/cmake/KDEConnect)

=== kcm/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN="kdeconnect-kcm")

include_directories(${CMAKE_CURRENT_BINARY_DIR}
                    ${CMAKE_CURRENT_SOURCE_DIR}
                    ${CMAKE_SOURCE_DIR}
                    ${CMAKE_BINARY_DIR})

set(kcm_SRCS
    kcm.cpp
)

ki18n_wrap_ui(kcm_SRCS kcm.ui)

add_library(kcm_kdeconnect MODULE ${kcm_SRCS})

target_link_libraries(kcm_kdeconnect
    Qt5::Core
    Qt5::Gui
    KF5::I18n
    KF5::KCMUtils
    kdeconnectinterfaces
)

install(TARGETS kcm_kdeconnect DESTINATION ${PLUGIN_INSTALL_DIR})

install(FILES org.kde.kdeconnect.kcm.desktop DESTINATION ${XDG_APPS_INSTALL_DIR})
install(FILES kcm_kdeconnect.desktop DESTINATION ${SERVICES_INSTALL_DIR})

=== kcmplugin/CMakeLists.txt ===
project(kdeconnectpluginkcm)

add_definitions(-DTRANSLATION_DOMAIN=\"kdeconnect-core\")

add_library(kdeconnectpluginkcm kdeconnectpluginkcm.cpp)
target_link_libraries(kdeconnectpluginkcm
PUBLIC
    kdeconnectcore
PRIVATE
    Qt5::DBus
    Qt5::Gui
    KF5::I18n
    KF5::ConfigCore
    KF5::KCMUtils
)

set_target_properties(kdeconnectpluginkcm PROPERTIES
    VERSION ${KDECONNECT_VERSION}
    SOVERSION ${KDECONNECT_VERSION_MAJOR}
)

target_include_directories(kdeconnectpluginkcm PUBLIC ${CMAKE_CURRENT_BINARY_DIR})
generate_export_header(kdeconnectpluginkcm EXPORT_FILE_NAME kdeconnectpluginkcm_export.h BASE_NAME kdeconnectpluginkcm)

# Remove NAMELINK_SKIP if/when headers are being installed and the library becomes public.
install(TARGETS kdeconnectpluginkcm EXPORT kdeconnectLibraryTargets ${INSTALL_TARGETS_DEFAULT_ARGS} LIBRARY NAMELINK_SKIP)

=== kio/CMakeLists.txt ===
--- 
+++ 
@@ -17,5 +17,6 @@
 )
 
 ########### install files ###############
-install(TARGETS kio_kdeconnect DESTINATION ${PLUGIN_INSTALL_DIR})
-install(FILES kdeconnect.protocol DESTINATION ${SERVICES_INSTALL_DIR})
+set_target_properties(kio_kdeconnect PROPERTIES OUTPUT_NAME "kdeconnect")
+set_target_properties(kio_kdeconnect PROPERTIES LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin/kf5/kio")
+install(TARGETS kio_kdeconnect DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf5/kio)

=== plugins/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR}/core)
add_definitions(-DTRANSLATION_DOMAIN=\"kdeconnect-plugins\")
install(FILES kdeconnect_plugin.desktop DESTINATION ${SERVICETYPES_INSTALL_DIR})

add_subdirectory(ping)
add_subdirectory(clipboard)
add_subdirectory(telephony)
add_subdirectory(share)
add_subdirectory(notifications)
add_subdirectory(battery)
add_subdirectory(findmyphone)
add_subdirectory(remotekeyboard)
if(WIN32)
    add_subdirectory(mousepad_windows)
else()
    add_subdirectory(runcommand)
    add_subdirectory(sendnotifications)
    add_subdirectory(pausemusic)
    add_subdirectory(mpriscontrol)
    add_subdirectory(mousepad)
    add_subdirectory(screensaver-inhibit)
    add_subdirectory(sftp)
endif()
if(EXPERIMENTALAPP_ENABLED)
    add_subdirectory(remotecommands)
    add_subdirectory(mprisremote)
    add_subdirectory(remotecontrol)
    add_subdirectory(lockdevice)
endif()

#FIXME: If we split notifications in several files, they won't appear in the same group in the Notifications KCM
install(FILES kdeconnect.notifyrc DESTINATION ${KNOTIFYRC_INSTALL_DIR})

=== tests/CMakeLists.txt ===
find_package(Qt5 ${QT_MIN_VERSION} REQUIRED COMPONENTS Test)

include_directories(
    ${KDEConnectCore_BINARY_DIR}
    ${CMAKE_SOURCE_DIR}
)

set(kdeconnect_libraries
	kdeconnectcore
    KF5::I18n
    KF5::KIOWidgets
    Qt5::DBus
    Qt5::Network
    Qt5::Test
    qca-qt5
)

ecm_add_test(pluginloadtest.cpp LINK_LIBRARIES ${kdeconnect_libraries})
ecm_add_test(sendfiletest.cpp LINK_LIBRARIES ${kdeconnect_libraries})
ecm_add_test(networkpackettests.cpp LINK_LIBRARIES ${kdeconnect_libraries})
ecm_add_test(testsocketlinereader.cpp TEST_NAME testsocketlinereader LINK_LIBRARIES ${kdeconnect_libraries})
ecm_add_test(testsslsocketlinereader.cpp TEST_NAME testsslsocketlinereader LINK_LIBRARIES ${kdeconnect_libraries})
ecm_add_test(kdeconnectconfigtest.cpp TEST_NAME kdeconnectconfigtest LINK_LIBRARIES ${kdeconnect_libraries})
ecm_add_test(lanlinkprovidertest.cpp TEST_NAME lanlinkprovidertest LINK_LIBRARIES ${kdeconnect_libraries})
ecm_add_test(devicetest.cpp TEST_NAME devicetest LINK_LIBRARIES ${kdeconnect_libraries})
ecm_add_test(downloadjobtest.cpp TEST_NAME downloadjobtest LINK_LIBRARIES ${kdeconnect_libraries})
ecm_add_test(testnotificationlistener.cpp
             ../plugins/sendnotifications/sendnotificationsplugin.cpp
             ../plugins/sendnotifications/notificationslistener.cpp
             ../plugins/sendnotifications/notifyingapplication.cpp
             TEST_NAME testnotificationlistener
             LINK_LIBRARIES ${kdeconnect_libraries} Qt5::DBus KF5::Notifications KF5::IconThemes)

=== urlhandler/CMakeLists.txt ===
ki18n_wrap_ui(telhandler_SRCS dialog.ui)

add_executable(kdeconnect-handler kdeconnect-handler.cpp ${telhandler_SRCS})

target_link_libraries(kdeconnect-handler
    kdeconnectinterfaces
    Qt5::Widgets
    KF5::CoreAddons
    KF5::I18n
)

install(TARGETS kdeconnect-handler ${INSTALL_TARGETS_DEFAULT_ARGS})
install(PROGRAMS org.kde.kdeconnect.telhandler.desktop DESTINATION ${XDG_APPS_INSTALL_DIR} )

=== debian/changelog ===
kdeconnect (1.3.3-0ubuntu0.18.10.1) cosmic; urgency=medium

  * New upstream bugfix release (1.3.3) (LP: #1812408)
  * Update watch file.

 -- Rik Mills <rikmills@kubuntu.org>  Fri, 18 Jan 2019 19:49:13 +0000

=== debian/control ===
Source: kdeconnect
Section: kde
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Maximiliano Curia <maxy@debian.org>
Build-Depends:
 cmake (>= 3.0~),
 debhelper (>= 11~),
 extra-cmake-modules (>= 5.42.0~),
 libfakekey-dev,
 libkf5config-dev,
 libkf5configwidgets-dev (>= 5.42.0~),
 libkf5dbusaddons-dev (>= 5.42.0~),
 libkf5declarative-dev (>= 5.42.0~),
 libkf5doctools-dev (>= 5.42.0~),
 libkf5i18n-dev (>= 5.42.0~),
 libkf5iconthemes-dev (>= 5.42.0~),
 libkf5kcmutils-dev (>= 5.42.0~),
 libkf5kio-dev (>= 5.42.0~),
 libkf5notifications-dev (>= 5.42.0~),
 libkf5wayland-dev (>= 4:5.42.0~),
 libqca-qt5-2-dev (>= 2.1.0~),
 libqca-qt5-2-plugins,
 libqt5x11extras5-dev (>= 5.7.0~),
 libx11-dev,
 libxtst-dev,
 pkg-config,
 pkg-kde-tools,
 qtbase5-dev (>= 5.7.0~),
 qtdeclarative5-dev (>= 5.7.0~),
Standards-Version: 4.1.4
Homepage: https://community.kde.org/KDEConnect
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/kdeconnect.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/kdeconnect

Package: kdeconnect
Architecture: any
Depends:
 kde-cli-tools,
 libqca-qt5-2-plugins,
 plasma-framework,
 qml-module-qtquick-controls,
 qml-module-qtquick-controls2,
 qml-module-qtquick-layouts,
 qml-module-qtquick2,
 sshfs,
 ${misc:Depends},
 ${shlibs:Depends},
Suggests: plasma-workspace, python-nautilus
Description: connect smartphones to your KDE Plasma Workspace
 Tool to integrate the KDE Plasma Workspace with your smartphones and
 similar devices.
 It adds a set of plasmoid, plugins and services to the KDE Plasma Workspace.
 At the  moment it only supports Android based devices.

=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,5 @@
 #!/usr/bin/make -f
 # -*- makefile -*-
-
-include /usr/share/pkg-kde-tools/qt-kde-team/3/debian-qt-kde.mk
 
 # hardening options stuff
 DPKG_EXPORT_BUILDFLAGS = 1
@@ -12,10 +10,7 @@
 export LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS) -Wl,--as-needed
 
 %:
-	dh $@ --with=kf5,pkgkde-symbolshelper --parallel
-
-override_dh_install:
-	dh_install --list-missing
+	dh $@ --with=kf5,pkgkde-symbolshelper
 
 override_dh_auto_test:
 	# Disable dh_auto_test at build time

=== debian/watch ===
version=4
opts="pgpsigurlmangle=s/$/.sig/" \
https://download.kde.org/stable/kdeconnect/([\d\.]+)/src/kdeconnect-kde@ANY_VERSION@@ARCHIVE_EXT@

## kdeconnect 1.3.4

=== debian/changelog ===
kdeconnect (1.3.4-0ubuntu1) disco; urgency=medium

  * New upstream bugfix release (1.3.4).
  * Update watch file.

 -- Rik Mills <rikmills@kubuntu.org>  Mon, 25 Mar 2019 13:01:48 +0000

kdeconnect (1.3.3-2ubuntu2) disco; urgency=medium

  * Disable debian patch that fails to fix flaky ssl socket test on
    Ubuntu infra, and for now replace with patch that skips the test.

 -- Rik Mills <rikmills@kubuntu.org>  Wed, 16 Jan 2019 21:36:30 +0000

kdeconnect (1.3.3-2ubuntu1) disco; urgency=medium

  * Merge with Debian. Remaining changes:
    - Skip failing tests on unsupported s390x.
    - Update watch file.

 -- Rik Mills <rikmills@kubuntu.org>  Wed, 02 Jan 2019 08:44:40 +0000

kdeconnect (1.3.3-2) unstable; urgency=medium

  * Team upload.
  * Add ssl_socket_race_fix.diff to fix a race condition on tests.

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Sun, 30 Dec 2018 17:33:01 -0300

kdeconnect (1.3.3-1ubuntu1) disco; urgency=medium

  * Skip failing tests on unsupported s390x.

 -- Rik Mills <rikmills@kubuntu.org>  Tue, 13 Nov 2018 07:26:32 +0000

kdeconnect (1.3.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Simplify handling of build flags: debhelper since compat 9 already passes
    all the right flags to cmake, so use the dpkg-buildflags envvars to only
    link in as-needed mode.
  * Stop using the pkgkde-symbolshelper dh addon, since there are no symbols.
  * Bump Standards-Version to 4.2.1, no changes required.
  * Drop the Debian-provided kdeconnect-cli man page: very outdated, not
    touched in the last 4 years, and thus not useful. (Closes: #900710)

 -- Pino Toscano <pino@debian.org>  Mon, 12 Nov 2018 08:57:34 +0100

## kdeconnect 1.3.5

=== debian/changelog ===
kdeconnect (1.3.5-0ubuntu1) eoan; urgency=medium

  * New upstream bugfix release (1.3.5)

 -- Rik Mills <rikmills@kubuntu.org>  Tue, 30 Jul 2019 12:29:40 +0100

## kdeconnect 1.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project(kdeconnect)

if (SAILFISHOS)
    set(KF5_MIN_VERSION "5.31.0")
    set(QT_MIN_VERSION "5.6.0")
    set(QCA_MIN_VERSION "2.0.0")
else()
    set(KF5_MIN_VERSION "5.64.0")
    set(QT_MIN_VERSION "5.10.0")
    set(QCA_MIN_VERSION "2.1.0")
endif()

find_package(ECM ${KF5_MIN_VERSION} REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} ${CMAKE_SOURCE_DIR}/cmake)

include(KDEInstallDirs)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(KDECMakeSettings)
include(ECMAddTests)
include(ECMSetupVersion)
include(ECMInstallIcons)
include(FeatureSummary)
include(GenerateExportHeader)

include(KDEConnectMacros.cmake)

ecm_setup_version(1.4.0
    VARIABLE_PREFIX KDECONNECT
    VERSION_HEADER ${CMAKE_CURRENT_BINARY_DIR}/kdeconnect-version.h
)

if (SAILFISHOS)
    find_package(PkgConfig)
    set(KF5_REQUIRED_COMPONENTS I18n DBusAddons CoreAddons IconThemes Config)
    set(KF5_OPTIONAL_COMPONENTS)
    pkg_search_module(SFOS REQUIRED sailfishapp)
    pkg_check_modules(QCA2 qca2-qt5>=${QCA_MIN_VERSION} REQUIRED)
    add_definitions(-DSAILFISHOS)
    include_directories(${QCA2_INCLUDEDIR})
    add_definitions(-DQT_NO_URL_CAST_FROM_STRING)
else()
    set(KF5_REQUIRED_COMPONENTS I18n ConfigWidgets DBusAddons IconThemes Notifications KIO KCMUtils Service Kirigami2 People)
    set(KF5_OPTIONAL_COMPONENTS DocTools)

    set_package_properties(KF5Kirigami2 PROPERTIES
        DESCRIPTION "QtQuick plugins to build user interfaces based on KDE UX guidelines"
        PURPOSE "Required for KDE Connect's QML-based GUI applications"
        URL "https://www.kde.org/products/kirigami/"
        TYPE RUNTIME
    )

    if(UNIX AND NOT APPLE)
        find_package(KF5PulseAudioQt)
    endif()
    find_package(Qca-qt5 ${QCA_MIN_VERSION} REQUIRED)

    find_package(KF5PeopleVCard)
    set_package_properties(KF5PeopleVCard PROPERTIES
        PURPOSE "Read vcards from the file system"
        URL "https://phabricator.kde.org/source/kpeoplevcard/"
        TYPE RUNTIME
    )

    add_definitions(-DQT_NO_URL_CAST_FROM_STRING -DQT_NO_KEYWORDS -DQT_NO_CAST_FROM_ASCII -DHAVE_KIO)
endif()

find_package(Qt5 ${QT_MIN_VERSION} REQUIRED COMPONENTS Quick Network Multimedia)
find_package(KF5 ${KF5_MIN_VERSION} REQUIRED COMPONENTS ${KF5_REQUIRED_COMPONENTS})
if (KF5_OPTIONAL_COMPONENTS)
find_package(KF5 ${KF5_MIN_VERSION} COMPONENTS ${KF5_OPTIONAL_COMPONENTS})
endif()

if (NOT ZSH_AUTOCOMPLETE_DIR)
set(ZSH_AUTOCOMPLETE_DIR "${CMAKE_INSTALL_PREFIX}/share/zsh/site-functions")
endif()

option(PRIVATE_DBUS_ENABLED "Use private dbus session for kdeconnect" OFF)
if(PRIVATE_DBUS_ENABLED OR APPLE)
    add_compile_definitions(USE_PRIVATE_DBUS)
endif()

add_subdirectory(core)
add_subdirectory(icon)
add_subdirectory(interfaces)
add_subdirectory(data)
add_subdirectory(plugins)
add_subdirectory(cli)
add_subdirectory(declarativeplugin)

if(NOT SAILFISHOS)
    add_subdirectory(kcm)
    add_subdirectory(kcmplugin)
    add_subdirectory(daemon)
    add_subdirectory(app)
    add_subdirectory(indicator)
    add_subdirectory(urlhandler)
    add_subdirectory(nautilus-extension)
    add_subdirectory(fileitemactionplugin)
    add_subdirectory(smsapp)

    if(BUILD_TESTING)
        add_subdirectory(tests)
    endif()

    if(NOT WIN32)
        add_subdirectory(kio)
        add_subdirectory(plasmoid)
    endif()

    if(KF5DocTools_FOUND)
        add_subdirectory(doc)
    endif()
else()
    add_subdirectory(sfos)
endif()

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

find_package(KF5I18n CONFIG REQUIRED)
ki18n_install(po)

=== app/CMakeLists.txt ===
qt5_add_resources(kdeconnect_SRCS resources.qrc)

add_executable(kdeconnect-app main.cpp ${kdeconnect_SRCS})
target_link_libraries(kdeconnect-app Qt5::Quick Qt5::Widgets KF5::CoreAddons KF5::I18n)

install(TARGETS kdeconnect-app ${INSTALL_TARGETS_DEFAULT_ARGS})
install(PROGRAMS org.kde.kdeconnect.app.desktop DESTINATION ${XDG_APPS_INSTALL_DIR})

=== cli/CMakeLists.txt ===
--- 
+++ 
@@ -3,10 +3,14 @@
 add_executable(kdeconnect-cli kdeconnect-cli.cpp)
 ecm_mark_nongui_executable(kdeconnect-cli)
 
+target_include_directories(kdeconnect-cli PUBLIC ${CMAKE_BINARY_DIR})
+
 target_link_libraries(kdeconnect-cli
     kdeconnectinterfaces
+    kdeconnectcore
     KF5::CoreAddons
     KF5::I18n
 )
 
 install(TARGETS kdeconnect-cli ${INSTALL_TARGETS_DEFAULT_ARGS})
+install(FILES kdeconnect.zsh RENAME _kdeconnect DESTINATION ${ZSH_AUTOCOMPLETE_DIR})

=== core/CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,11 @@
-project(KDEConnectCore)
-
 add_definitions(-DTRANSLATION_DOMAIN=\"kdeconnect-core\")
 
-include_directories(
-    ${CMAKE_CURRENT_BINARY_DIR}
-)
+set(KDECONNECT_PRIVATE_DBUS_ADDR unix:tmpdir=/tmp)
+if(WIN32)
+    set(KDECONNECT_PRIVATE_DBUS_ADDR tcp:host=localhost,port=0)
+endif()
+set(KDECONNECT_PRIVATE_DBUS_NAME DBusKDEConnectOnly)
+configure_file(dbushelper.h.in ${CMAKE_CURRENT_BINARY_DIR}/dbushelper.h)
 
 add_subdirectory(backends/lan)
 add_subdirectory(backends/loopback)
@@ -14,6 +15,8 @@
     find_package(Qt5 ${QT_MIN_VERSION} REQUIRED COMPONENTS Bluetooth)
     add_subdirectory(backends/bluetooth)
 endif()
+
+option(LOOPBACK_ENABLED "Loopback backend enabled" OFF)
 
 set(kdeconnectcore_SRCS
     ${backends_kdeconnect_SRCS}
@@ -31,12 +34,17 @@
     dbushelper.cpp
     networkpacket.cpp
     filetransferjob.cpp
+    compositefiletransferjob.cpp
     daemon.cpp
     device.cpp
     core_debug.cpp
+    notificationserverinfo.cpp
 )
 
 add_library(kdeconnectcore ${kdeconnectcore_SRCS})
+
+target_include_directories(kdeconnectcore PUBLIC ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_SOURCE_DIR})
+
 target_link_libraries(kdeconnectcore
 PUBLIC
     Qt5::Network
@@ -44,14 +52,21 @@
     qca-qt5
 PRIVATE
     Qt5::DBus
-    Qt5::Gui
     KF5::I18n
     KF5::ConfigCore
 )
 
+if(${KF5KIO_FOUND})
+    target_link_libraries(kdeconnectcore PUBLIC KF5::KIOCore)
+endif()
+
 if (BLUETOOTH_ENABLED)
     target_compile_definitions(kdeconnectcore PRIVATE -DKDECONNECT_BLUETOOTH)
     target_link_libraries(kdeconnectcore PRIVATE Qt5::Bluetooth)
+endif()
+
+if (LOOPBACK_ENABLED)
+    target_compile_definitions(kdeconnectcore PRIVATE -DKDECONNECT_LOOPBACK)
 endif()
 
 set_target_properties(kdeconnectcore PROPERTIES
@@ -59,7 +74,6 @@
     SOVERSION ${KDECONNECT_VERSION_MAJOR}
 )
 
-target_include_directories(kdeconnectcore PUBLIC ${CMAKE_CURRENT_BINARY_DIR})
 generate_export_header(kdeconnectcore EXPORT_FILE_NAME kdeconnectcore_export.h BASE_NAME KDEConnectCore)
 
 install(TARGETS kdeconnectcore EXPORT kdeconnectLibraryTargets ${INSTALL_TARGETS_DEFAULT_ARGS} LIBRARY NAMELINK_SKIP)

=== daemon/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN="kdeconnect-kded")

add_executable(kdeconnectd kdeconnectd.cpp)
target_include_directories(kdeconnectd PUBLIC ${CMAKE_BINARY_DIR})
target_link_libraries(kdeconnectd kdeconnectcore KF5::KIOWidgets KF5::DBusAddons KF5::Notifications KF5::I18n Qt5::Widgets)

ecm_mark_nongui_executable(kdeconnectd)

configure_file(org.kde.kdeconnect.daemon.desktop.cmake ${CMAKE_CURRENT_BINARY_DIR}/org.kde.kdeconnect.daemon.desktop)
configure_file(org.kde.kdeconnect.service.in ${CMAKE_CURRENT_BINARY_DIR}/org.kde.kdeconnect.service)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.kde.kdeconnect.daemon.desktop DESTINATION ${AUTOSTART_INSTALL_DIR})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.kde.kdeconnect.daemon.desktop DESTINATION ${XDG_APPS_INSTALL_DIR})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.kde.kdeconnect.service DESTINATION ${DBUS_SERVICES_INSTALL_DIR})
install(TARGETS kdeconnectd DESTINATION ${LIBEXEC_INSTALL_DIR})

=== data/CMakeLists.txt ===
install (FILES "kdeconnect.contract" DESTINATION ${CMAKE_INSTALL_PREFIX}/share/contractor/)
install (FILES "kdeconnect-thunar.desktop" DESTINATION ${CMAKE_INSTALL_PREFIX}/share/Thunar/sendto/)
install(PROGRAMS org.kde.kdeconnect_open.desktop DESTINATION ${XDG_APPS_INSTALL_DIR})

if(NOT SAILFISHOS)
    install(FILES org.kde.kdeconnect.kcm.appdata.xml DESTINATION ${KDE_INSTALL_METAINFODIR})
endif()

=== doc/CMakeLists.txt ===
kdoctools_create_handbook(index.docbook INSTALL_DESTINATION ${HTML_INSTALL_DIR}/en SUBDIR kdeconnect)

=== fileitemactionplugin/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN="kdeconnect-fileitemaction")

add_library(kdeconnectfileitemaction MODULE sendfileitemaction.cpp)
target_link_libraries(
    kdeconnectfileitemaction
    KF5::KIOWidgets
    KF5::I18n
    kdeconnectinterfaces
    kdeconnectcore
)
install(TARGETS kdeconnectfileitemaction DESTINATION ${PLUGIN_INSTALL_DIR}/kf5/kfileitemaction)

=== icon/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,5 @@
 
-ecm_install_icons(
-ICONS
+set(APP_ICONS
     256-apps-kdeconnect.png
     128-apps-kdeconnect.png
     32-apps-kdeconnect.png
@@ -9,6 +8,18 @@
     22-apps-kdeconnect.png
     16-apps-kdeconnect.png
     sc-apps-kdeconnect.svgz
+    sc-apps-kdeconnectindicator.svg
+)
+
+if(WIN32)
+    list(APPEND APP_ICONS sc-apps-kdeconnectindicatorwin.svg)
+else()
+    list(APPEND APP_ICONS sc-apps-kdeconnectindicatordark.svg)
+endif()
+
+ecm_install_icons(
+ICONS
+    ${APP_ICONS}
 DESTINATION
     ${ICON_INSTALL_DIR}
 )
@@ -24,6 +35,9 @@
     32-status-tabletconnected.png
     32-status-tabletdisconnected.png
     32-status-tablettrusted.png
+    32-status-tvconnected.png
+    32-status-tvdisconnected.png
+    32-status-tvtrusted.png
     sc-status-laptopconnected.svg
     sc-status-laptopdisconnected.svg
     sc-status-laptoptrusted.svg
@@ -33,6 +47,9 @@
     sc-status-tabletconnected.svg
     sc-status-tabletdisconnected.svg
     sc-status-tablettrusted.svg
+    sc-status-tvconnected.svg
+    sc-status-tvdisconnected.svg
+    sc-status-tvtrusted.svg
 DESTINATION
     ${ICON_INSTALL_DIR}
 )

=== indicator/CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,21 @@
 )
 
 add_executable(kdeconnect-indicator ${indicator_SRCS})
-target_link_libraries(kdeconnect-indicator Qt5::Widgets KF5::CoreAddons KF5::I18n KF5::Notifications KF5::DBusAddons KF5::KCMUtils kdeconnectinterfaces)
+target_include_directories(kdeconnect-indicator PUBLIC ${CMAKE_BINARY_DIR})
+target_link_libraries(kdeconnect-indicator Qt5::Widgets KF5::CoreAddons KF5::I18n KF5::Notifications KF5::DBusAddons KF5::KCMUtils kdeconnectinterfaces kdeconnectcore)
+if (WIN32)
+    add_compile_definitions(QSYSTRAY)
+endif()
+
+if (APPLE)
+# Apple app package
+set_target_properties(kdeconnect-indicator PROPERTIES MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_SOURCE_DIR}/Info.plist)
+set_target_properties(kdeconnect-indicator PROPERTIES
+    MACOSX_BUNDLE_BUNDLE_NAME "KDE Connect"
+    MACOSX_BUNDLE_LONG_VERSION_STRING "${KDECONNECT_VERSION_STRING}"
+    MACOSX_BUNDLE_SHORT_VERSION_STRING "${KDECONNECT_VERSION_MAJOR}.${KDECONNECT_VERSION_MINOR}.${KDECONNECT_VERSION_PATCH}"
+    MACOSX_BUNDLE_GUI_IDENTIFIER "org.kde.kdeconnect")
+endif()
 
 install(TARGETS kdeconnect-indicator ${INSTALL_TARGETS_DEFAULT_ARGS})
 install(PROGRAMS org.kde.kdeconnect.nonplasma.desktop DESTINATION ${XDG_APPS_INSTALL_DIR})

=== interfaces/CMakeLists.txt ===
function(geninterface source_h output_h)
    set(xml_file ${CMAKE_CURRENT_BINARY_DIR}/${output_h}.xml)
    qt5_generate_dbus_interface( ${source_h} ${xml_file})

    set_source_files_properties(${xml_file} PROPERTIES NO_NAMESPACE true)

    qt5_add_dbus_interface(libkdeconnect_SRC ${xml_file} ${output_h})
    set(libkdeconnect_SRC ${libkdeconnect_SRC} PARENT_SCOPE)
endfunction()

set(libkdeconnect_SRC
    dbusinterfaces.cpp
    devicesmodel.cpp
    notificationsmodel.cpp
    devicessortproxymodel.cpp
    conversationmessage.cpp
    remotecommandsmodel.cpp
    remotesinksmodel.cpp
    devicespluginfilterproxymodel.cpp
#    modeltest.cpp
)

geninterface(${CMAKE_SOURCE_DIR}/core/daemon.h daemoninterface)
geninterface(${CMAKE_SOURCE_DIR}/core/device.h deviceinterface)
geninterface(${CMAKE_SOURCE_DIR}/plugins/battery/batterydbusinterface.h devicebatteryinterface)
geninterface(${CMAKE_SOURCE_DIR}/plugins/sftp/sftpplugin.h devicesftpinterface)
geninterface(${CMAKE_SOURCE_DIR}/plugins/notifications/notificationsdbusinterface.h devicenotificationsinterface)
geninterface(${CMAKE_SOURCE_DIR}/plugins/findmyphone/findmyphoneplugin.h devicefindmyphoneinterface)
geninterface(${CMAKE_SOURCE_DIR}/plugins/notifications/notification.h notificationinterface)
geninterface(${CMAKE_SOURCE_DIR}/plugins/mprisremote/mprisremoteplugin.h mprisremoteinterface)
geninterface(${CMAKE_SOURCE_DIR}/plugins/remotecontrol/remotecontrolplugin.h remotecontrolinterface)
geninterface(${CMAKE_SOURCE_DIR}/plugins/lockdevice/lockdeviceplugin.h lockdeviceinterface)
geninterface(${CMAKE_SOURCE_DIR}/plugins/remotecommands/remotecommandsplugin.h remotecommandsinterface)
geninterface(${CMAKE_SOURCE_DIR}/plugins/remotekeyboard/remotekeyboardplugin.h remotekeyboardinterface)
geninterface(${CMAKE_SOURCE_DIR}/plugins/sms/smsplugin.h smsinterface)
geninterface(${CMAKE_SOURCE_DIR}/plugins/sms/conversationsdbusinterface.h conversationsinterface)
geninterface(${CMAKE_SOURCE_DIR}/plugins/share/shareplugin.h shareinterface)
geninterface(${CMAKE_SOURCE_DIR}/plugins/remotesystemvolume/remotesystemvolumeplugin.h remotesystemvolumeinterface)

add_library(kdeconnectinterfaces SHARED ${libkdeconnect_SRC})
set_target_properties(kdeconnectinterfaces PROPERTIES
    VERSION ${KDECONNECT_VERSION}
    SOVERSION ${KDECONNECT_VERSION_MAJOR}
)

generate_export_header(kdeconnectinterfaces EXPORT_FILE_NAME ${CMAKE_CURRENT_BINARY_DIR}/kdeconnectinterfaces_export.h BASE_NAME KDEConnectInterfaces)

target_link_libraries(kdeconnectinterfaces
LINK_PUBLIC
    Qt5::Gui
    Qt5::DBus
LINK_PRIVATE
    KF5::ConfigCore
    KF5::I18n
    kdeconnectcore
)

install(TARGETS kdeconnectinterfaces EXPORT kdeconnectLibraryTargets ${INSTALL_TARGETS_DEFAULT_ARGS} LIBRARY NAMELINK_SKIP)

=== kcm/CMakeLists.txt ===
--- 
+++ 
@@ -8,6 +8,10 @@
 set(kcm_SRCS
     kcm.cpp
 )
+
+set(kcm_wrapper_SRCS main.cpp)
+add_executable(kdeconnect-settings ${kcm_wrapper_SRCS})
+target_link_libraries(kdeconnect-settings KF5::I18n KF5::KCMUtils)
 
 ki18n_wrap_ui(kcm_SRCS kcm.ui)
 
@@ -22,6 +26,7 @@
 )
 
 install(TARGETS kcm_kdeconnect DESTINATION ${PLUGIN_INSTALL_DIR})
+install(TARGETS kdeconnect-settings ${INSTALL_TARGETS_DEFAULT_ARGS})
 
 install(FILES org.kde.kdeconnect.kcm.desktop DESTINATION ${XDG_APPS_INSTALL_DIR})
 install(FILES kcm_kdeconnect.desktop DESTINATION ${SERVICES_INSTALL_DIR})

=== debian/changelog ===
kdeconnect (1.4-0ubuntu5) focal; urgency=medium

  * Add patch to fix device filesystem browsing with openssh 8.2. Thanks
    to Antonio Rojas from ArchLinux. (LP: #1872075)
    - debian/patches: kdeconnect-openssh-8.2.patch

 -- Rik Mills <rikmills@kde.org>  Sun, 12 Apr 2020 13:39:05 +0100

kdeconnect (1.4-0ubuntu4) focal; urgency=medium

  * debian/control: Changes recommended/requested by KDE developers.
    - Drop suggests on plasma-workspace. Installing just this in a non
      Plasma environment will not make the plasmoid usable, and the non
      plasma application indicator works in such an environment without
      plasma-workspace being installed. The suggests is therefore of no
      value, and may confuse users.
    - Update description to better describe latest device support and
      capabilities.
    - Change homepage to the new project website.

 -- Rik Mills <rikmills@kde.org>  Wed, 01 Apr 2020 18:56:00 +0100

kdeconnect (1.4-0ubuntu3) focal; urgency=medium

  * Recommend kpeople-vcard.

 -- Rik Mills <rikmills@kde.org>  Tue, 31 Mar 2020 12:50:04 +0100

kdeconnect (1.4-0ubuntu2) focal; urgency=medium

  * Add dependency qml-module-org-kde-people for the kdeconnect-sms app.
    (LP #1864389)

 -- Rik Mills <rikmills@kde.org>  Sun, 23 Feb 2020 22:23:47 +0000

kdeconnect (1.4-0ubuntu1) focal; urgency=medium

  * New upstream release (1.4)
  * New build depends on libkf5pulseaudioqt-dev,kirigami2-dev,
    libkf5people-dev and qtmultimedia5-dev
  * Drop upstream applied fix_typos_in_lanlinkprovider.cpp.patch.
  * Update lintian overrides.

 -- Rik Mills <rikmills@kde.org>  Sun, 08 Dec 2019 21:30:08 +0000

=== debian/control ===
Source: kdeconnect
Section: kde
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Maximiliano Curia <maxy@debian.org>
Build-Depends:
 cmake (>= 3.0~),
 debhelper (>= 11~),
 extra-cmake-modules (>= 5.42.0~),
 kirigami2-dev,
 libfakekey-dev,
 libkf5config-dev,
 libkf5configwidgets-dev (>= 5.42.0~),
 libkf5dbusaddons-dev (>= 5.42.0~),
 libkf5declarative-dev (>= 5.42.0~),
 libkf5doctools-dev (>= 5.42.0~),
 libkf5i18n-dev (>= 5.42.0~),
 libkf5iconthemes-dev (>= 5.42.0~),
 libkf5kcmutils-dev (>= 5.42.0~),
 libkf5kio-dev (>= 5.42.0~),
 libkf5notifications-dev (>= 5.42.0~),
 libkf5people-dev,
 libkf5pulseaudioqt-dev,
 libkf5wayland-dev (>= 4:5.42.0~),
 libqca-qt5-2-dev (>= 2.1.0~),
 libqca-qt5-2-plugins,
 libqt5x11extras5-dev (>= 5.7.0~),
 libx11-dev,
 libxtst-dev,
 pkg-config,
 pkg-kde-tools,
 qtbase5-dev (>= 5.7.0~),
 qtdeclarative5-dev (>= 5.7.0~),
 qtmultimedia5-dev,
Standards-Version: 4.2.1
Homepage: https://kdeconnect.kde.org
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/kdeconnect.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/kdeconnect

Package: kdeconnect
Architecture: any
Depends:
 kde-cli-tools,
 libqca-qt5-2-plugins,
 plasma-framework,
 qml-module-org-kde-people,
 qml-module-qtquick-controls,
 qml-module-qtquick-controls2,
 qml-module-qtquick-layouts,
 qml-module-qtquick2,
 sshfs,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends: kpeople-vcard,
Suggests: python-nautilus
Description: connect smartphones to your desktop devices.
 Tool to integrate your smartphone, Tablet, and desktop devices.
 Remote-control, share files, synchronize notifications, and more!
 At the moment it only supports Android-based mobile devices. Linux desktop
 devices are well-supported, with ports available for other operating systems.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed

%:
	dh $@ --with=kf5

override_dh_auto_test:
	# Disable dh_auto_test at build time
	:

=== debian/tests/control ===
Tests: testsuite
Depends: @, @builddeps@, xvfb, xauth, openbox, dbus (>= 1.8)
Restrictions: build-needed, allow-stderr

=== debian/watch ===
version=4
opts="pgpsigurlmangle=s/$/.sig/" \
https://download.kde.org/stable/kdeconnect/([\d\.]+)/kdeconnect-kde@ANY_VERSION@@ARCHIVE_EXT@
